<?php

namespace Drupal\krumo\Plugin\Devel\Dumper;

use Drupal\devel\DevelDumperBase;

/**
 * Provides a Krumo dumper plugin.
 *
 * @DevelDumper(
 *   id = "krumo",
 *   label = @Translation("Krumo"),
 *   description = @Translation("Wrapper for <a href="https://github.com/mmucklo/krumo">Krumo</a>, a debugging tool."),
 * )
 */
class Krumo extends DevelDumperBase {

    /**
     * {@inheritdoc}
     */
    public function dump($input, $name = NULL) {
        echo $this->export($input, $name);
    }

    /**
     * {@inheritdoc}
     */
    public function export($input, $name = NULL) {
        return $this->setSafeMarkup(\Krumo::dump($input));
    }

    /**
     * {@inheritdoc}
     */
    public function exportAsRenderable($input, $name = NULL) {
      return [
        '#attached' => [
          'library' => ['krumo/krumo'],
        ],
        '#markup' => $this->export($input, $name),
      ];
    }

    /**
     * {@inheritdoc}
     */
    public static function checkRequirements() {
      return class_exists('Krumo', TRUE);
    }

}
